#import "PreferenceController.h"


 

@implementation PreferenceController




- (void) awakeFromNib
{
	md = [MyDocument alloc];
	[md init];
	
	//ss = [StyleSheets alloc];
	//[ss init];
	
	WebView *wv = [WebView alloc];
	[wv init];
	[wv setPreferencesIdentifier:@"Bovine"];
	
	p = [wv preferences];
	[p setAutosaves:YES];
	
	NSUserDefaults *defaults;
	defaults = [NSUserDefaults standardUserDefaults];
	NSString *dHomepage = [defaults stringForKey:@"defaultHomepage"];
	if (dHomepage != nil)
	{
		[md setDefaultHomepage:dHomepage];
	}
}


- (IBAction)apply:(id)sender
{

	NSUserDefaults *defaults;
	defaults = [NSUserDefaults standardUserDefaults];
	
	NSString* dHomepage = [defaultHomepage stringValue];
	[defaults setObject:dHomepage forKey:@"defaultHomepage"];
	[md setDefaultHomepage:dHomepage];
	
	
	
	[p setAutosaves:YES];
  
	if ([autoloadImages state] == NSOffState){
		[p setLoadsImagesAutomatically:NO];
	}
	else {
		[p setLoadsImagesAutomatically:YES];
	}
	
	if ([allowAnimatedImages state] == NSOffState){
		[p setAllowsAnimatedImageLooping:NO];
	}
	else {
		[p setAllowsAnimatedImageLooping:YES];
	}
	
	if ([javaScriptEnabled state] == NSOffState)
	{
		[p setJavaScriptEnabled:NO];
	}
	else 
	{
		[p setJavaScriptEnabled:YES];
	}
	
	if ([userSSEnabled state] == NSOffState)
	{
		[p setUserStyleSheetEnabled:NO];
	}
	else 
	{
		
		NSError *error;
		BOOL ok;
		NSString *css = [NSString stringWithFormat:@"%@%@", [FontColour stringValue], [BackgroundColour stringValue]];  
		NSString *fullPath = [NSHomeDirectory() stringByAppendingPathComponent:[css stringByAppendingPathExtension:@"css"]];     
		//NSLog(@"Writing file at %@\n", fullPath);
		
		ok = [[self getStyleSheet:[FontColour stringValue] background:[BackgroundColour stringValue]] writeToFile:fullPath atomically:YES encoding:NSUnicodeStringEncoding error:&error];
		
		if (!ok) 
		{    // an error occurred
			NSLog(@"Error writing file at %@\n%@", fullPath, [error localizedFailureReason]);
		}		
		
		//NSLog(@"File url= %@\n", [[p userStyleSheetLocation] absoluteString]);
		
		[p setUserStyleSheetLocation:[NSURL fileURLWithPath:fullPath]];
		[p setUserStyleSheetEnabled:YES];
  }
  


}

- (void)windowDidBecomeKey:(NSNotification *)aNotification
{
	[defaultHomepage setStringValue:[md getDefaultHomepage]];
	
	[p setAutosaves:YES];
	
	if ([p loadsImagesAutomatically]){
		[autoloadImages setState:NSOnState];
	}
	else 
	{
		[autoloadImages setState:NSOffState];
	}
	
	if ([p allowsAnimatedImageLooping]){
		[allowAnimatedImages setState:NSOnState];
	}
	else
	{
		[allowAnimatedImages setState:NSOffState];
	}
	
	if ([p isJavaScriptEnabled]){
		[javaScriptEnabled setState:NSOnState];
	}
	else 
	{
		[javaScriptEnabled setState:NSOffState];
	}
	
	if ([p userStyleSheetEnabled])
	{
		[userSSEnabled setState:NSOnState];
	}
	else 
	{
		[userSSEnabled setState:NSOffState];
	}
}

- (IBAction)openPreferences:(id)sender
{
	[auxWindow makeKeyAndOrderFront:auxWindow];
}



- (NSString *)getStyleSheet:(NSString *)fontColor background:(NSString *)backgroundColor
{
	
	NSMutableString * cssString = [NSMutableString stringWithString:@"/* background BACKGROUNDCOLOR foreground FOREGROUNDCOLOR */ BODY, TABLE { overflow: hidden; font-weight: normal; font-family: sans-serif; background: BACKGROUNDCOLOR !important; color: FOREGROUNDCOLOR !important; } h1, h2, h3 { color: FOREGROUNDCOLOR !important; background: BACKGROUNDCOLOR !important; } * { color: FOREGROUNDCOLOR !important; background: BACKGROUNDCOLOR !important; } a:focus { border:solid blue 2px; } a:visited img { border: solid purple 1px;} a:focus img { border:solid blue 2px; } a:hover img { border:solid blue 2px; } "];
	
	
	[cssString replaceOccurrencesOfString:@"BACKGROUNDCOLOR" withString:backgroundColor options:NSLiteralSearch
                            range:NSMakeRange(0, [cssString length])];
	
							
	[cssString replaceOccurrencesOfString:@"FOREGROUNDCOLOR" withString:fontColor options:NSLiteralSearch
                            range:NSMakeRange(0, [cssString length])];	
		
	
	return cssString;
	
}




@end
